void fileSelected(File selection) {
  if (selection == null) {
    println("file selection canceled.");
  } else {
    input = loadStrings(selection);
    LoadSettings();
  }
}

void LoadSettings() {
  birdxlo = int(input[0]);
  spd = splitTokens(input[12], ", ");
  yps = splitTokens(input[13], ", ");
  bgc = splitTokens(input[14], ", ");
  int L = spd.length;
  target = L;
  if (L != yps.length) {println("ERROR: something is wrong."); exit();}
  imgwidth = int(L*1.5)+60;
  original = createImage(imgwidth, ysplit, RGB);
  current = original;
  previous = current;

  ninja = new PVector[L];
  bird = new PVector[L];
  tiles = new int[bgc.length]; 
  for (int i = 0; i < bgc.length; i++)
    {tiles[i] = int(bgc[i]);}
  for (int i = 0; i < L; i++) {
    bird[i]  = new PVector();
    ninja[i] = new PVector(0, int(yps[i])-hudoff, int(spd[i]));
  }
  f = 0;
  ResetVars();
}

void ResetVars() { // call this after any changes to redraw
  int i     = 1;
  ryuPos    = int(input[i++]);
  screen    = int(input[i++]);
  origin    = screen+ryuPos-0x1000;
  roomSize  = int(input[i++]);
  goleft    = int(input[i++]);
  screenP   = int(input[i++]);
  birdPos   =(int(input[i++])&0xff00) + birdxlo; // keep that low byte out of here!
  birdY     = int(input[i++])-hudoff;
  birdVel   = int(input[i++]);
  frame     = int(input[i++]);
  loading   = boolean(input[i++]);
  scroll    = boolean(input[i]);
  collision = false;
  isbird    = true;
  update    = true;
  compare   = false;
  colstr    = "";
  if (goleft != 0) origin = origin+0x1000-(imgwidth<<8);
}
